/**
 *
 * $Id: screen.cpp,v 1.4 2004/12/06 07:31:38 mviara Exp $
 * $Author: mviara $
 * $Name:  $
 *
 * Gestione screen virtuali.
 * 
 * $Log: screen.cpp,v $
 * Revision 1.4  2004/12/06 07:31:38  mviara
 * Bug fixed in ESC 1 K
 *
 * Revision 1.3  2004/11/30 20:06:41  mviara
 * Added support for hide/show cursor.
 * Set default to green on black.
 *
 * Revision 1.2  2004/07/10 13:59:12  mviara
 * Some minor changes.
 *
 * Revision 1.1.1.1  2004/07/10 12:33:22  mviara
 * Migrated from RCS
 *
 *
 * 
 */

#include "ansi.hpp"
static char rcsinfo[]= "$Id: screen.cpp,v 1.4 2004/12/06 07:31:38 mviara Exp $";

	

void CAnsi::CScreen::Print(char chr,int num)
{
	SCHAR ch;
	
	ch.color = (unsigned char)curColor;
	ch.chr = chr;
	while (num--)
		buffer[curPos++] = ch;
	
}

CAnsi::CScreen::~CScreen()
{
	delete buffer;
}

void CAnsi::CScreen::Default()
{
	DisplayChar  = CAnsi::DisplayNormal;
        gvt100 = 0;
	autoWrap = 1;
	orMask = 0;
	bscroll = 0;
	escroll = numRow - 1;
	//cursorOn = 1;				// cursore attivo
	flagScrollOff = 0;			// scroll attivo
	wrapped = 0;
	
}

CAnsi::CScreen::CScreen(int row,int col)
{
	int i;
	SCHAR tmp;

	tmp.chr = ' ';
	tmp.color = 7;
	
	buffer = new SCHAR[(row+1)*col];
	numRow = row;
	numCol = col;
	
	assert(buffer != 0);
	for (i = 0 ; i < row*col ; i++)
	{
		buffer[i] = tmp;
	}
	
	
	for (i = 0 ; i < FCNKEY ; i++)
		lenght[i] = 0;

	ps = pl = 0;
	fnormal = fcolor = freverse = 2;
	bcolor = bnormal = breverse = 0;
	reverse = hi = blink = 0;
	curColor = fnormal;
	cursorOn = 1;

	Default();
}
